# © Copyright [2016 - 2020] Micro Focus or one of its affiliates.
#
# The only warranties for products and services of Micro Focus and its affiliates and licensors
# (“Micro Focus”) are as may be set forth in the express warranty statements accompanying such
# products and services. Nothing herein should be construed as constituting an additional
# warranty. Micro Focus shall not be liable for technical or editorial errors or omissions
# contained herein. The information contained herein is subject to change without notice.
#
# Except as specifically indicated otherwise, this document contains confidential information
# and a valid license is required for possession, use or copying. If this work is provided to the
# U.S. Government, consistent with FAR 12.211 and 12.212, Commercial Computer Software,
# Computer Software Documentation, and Technical Data for Commercial Items are licensed
# to the U.S. Government under vendor's standard commercial license.


ZK_PORT=$1
if  ! [[ $1 =~ ^[0-9]+$ ]]; then  # && [[ $1 -gt 0 ]]; then
	logger -t cis "Argument '$1' is not valid port"
	exit 1
else
	if [[ $1 -lt 1 || $1 -gt 65535 ]]; then
		logger -t cis "Argument '$1' is not valid port"
		exit 1
	fi
fi

PORT_ALREADY_ADDED=false
PORTS=`grep "^FW_SERVICES_EXT_TCP" /etc/sysconfig/SuSEfirewall2 | cut -d= -f2 | sed -e 's/^"//' -e 's/"$//'`
#echo $PORTS

PORTS_LIST=( $PORTS )
for ((i = 0; i < ${#PORTS_LIST[@]}; i++))
do
   if [ "${PORTS_LIST[$i]}" == "$ZK_PORT" ]; then
#	echo "${PORTS_LIST[$i]}"
	PORT_ALREADY_ADDED=true
   fi
done
if [ $PORT_ALREADY_ADDED == "false" ]; then
#	echo "Adding the port $ZK_PORT "
	SUSEfirewall2 open EXT TCP $ZK_PORT
	if [ $? -ne 0 ]; then
		logger -t cis "Failed to open up the port for ZooKeeper.\n"
		exit 1;
	fi
	systemctl status SuSEfirewall2
	if [ $? -eq 0 ]; then
		systemctl restart SuSEfirewall2
		if [ $? -ne 0 ]; then
			logger -t cis "Failed to restart the SuSEfirewall.\n"
			exit 1;
		fi
	fi
fi
